/*
 * Copyright (C) 2012 nico3000 - All Rights Reserved
 */
package actor.components;

import logging.Logger;
import main.GameApp;

import org.w3c.dom.Node;

import util.Pose;
import actor.ActorComponent;
import actor.ActorFactory;
import event.events.ActorMovedEvent;


/**
 *
 * @author nico3000
 */
public class TransformComponent extends ActorComponent {
    /**
     * ID der Komponente.
     */
    public static final int ID = 0x16173e9f;
    
    /**
     * Die Pose des Actors.
     */
    private Pose pose = null;

    @Override
    protected int getComponentId() {
        return ID;
    }

    @Override
    protected boolean init(Node data) {
        this.pose = new Pose(this.getOwner().getId());
        this.pose.setFromXml(data);
        return true;
    }

    @Override
    protected void update(long deltaMillis) {
        if(this.pose.updateModel() && this.getOwner().getId() != ActorFactory.INVALID_ACTOR_ID) {
            //TODO trigger needed!
            GameApp.getEventManager().triggerEvent(new ActorMovedEvent(this.getOwner().getId()));
        }
    }

    /**
     * Liefert die Pose des Objekts.
     * @return Die Pose
     */
    public Pose getPose() {
        return this.pose;
    }

}
