/*
 * Copyright (C) 2012 nico3000 - All Rights Reserved
 */
package event.events;

import event.EventData;

/**
 * Ein allgemeines ActorEvent speichert eine ActorID mit.
 * @author nico3000
 */
public abstract class ActorEvent extends EventData {
    /**
     * Die ID des Actors, der sich bewegt hat.
     */
    private final int actorId;
    
    /**
     * Konstruktor.
     * @param actorId Die ID des Actors
     */
    public ActorEvent(int actorId) {
        this.actorId = actorId;
    }    
    
    /**
     * Liefert die ID des Actors, der sich bewegt hat.
     * @return Die ID des Actors
     */
    public int getActorId() {
        return actorId;
    }    
}
