/*
 * Copyright (C) 2012 nico3000 - All Rights Reserved
 */
package graphics.geometry;

import java.nio.IntBuffer;
import logging.Logger;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL15;
import org.lwjgl.opengl.GL30;

/**
 *
 * @author nico3000
 */
public class IndexBuffer {
    public static final int RESTART = 0xffffffff;
    public static final int TRIANGLE_STRIP = GL11.GL_TRIANGLE_STRIP;
    public static final int TRIANGLE_LIST = GL11.GL_TRIANGLES;
    public static final int TRIANGLE_FAN = GL11.GL_TRIANGLE_FAN;
    
    private int id = 0;
    private int topology;
    private int count = 0;
    
    public void bind() {
        GL15.glBindBuffer(GL15.GL_ELEMENT_ARRAY_BUFFER, this.id);
    }
    
    public boolean init() {
        this.id = GL15.glGenBuffers();
        return this.id != 0;
    }
    
    public void destroy() {
        if(this.id != 0) {
            GL15.glDeleteBuffers(this.id);
            this.id = 0;
        }
    }
    
    public void setData(IntBuffer data, int topology) {
        GL30.glBindVertexArray(0);
        this.bind();
        GL15.glBufferData(GL15.GL_ELEMENT_ARRAY_BUFFER, data, GL15.GL_STATIC_DRAW);
        this.topology = topology;
        this.count = data.remaining();
    }

    public int getCount() {
        return count;
    }

    public int getTopology() {
        return topology;
    }
}
