/*
 * This software is the proprietary information of nico3000.
 */
package gui;

import graphics.texture.Texture;
import java.awt.Rectangle;

/**
 *
 * @author nico3000
 */
public interface ComponentDrawer {
    public abstract boolean init();
    public abstract Texture createLabel(String content, int width, int height, boolean decorated);
    public abstract Texture createButton(String content, int width, int height, boolean focus, boolean hovered, boolean pressed);
    public abstract Texture createTextField(String text, int caretPosition, int fontSize, int width, int height);
    public abstract Texture createWindow(String title, Rectangle titleRect, Rectangle closeButtonRect, boolean focused, boolean closeable, boolean closeButtonPressed, int width, int height);
    public abstract Texture drawTextBlock(String text, int width);
    public abstract Texture createScrollbar(int width, int height, float scrolled);
}
