/*
 * This software is the proprietary information of nico3000.
 */
package gui.components;

import graphics.texture.TextureLoader;
import static gui.components.Component.REPAINT_ON_NULL_TEXTURE;
import main.GameApp;
import util.MathUtil;

/**
 *
 * @author nico3000
 */
public class Cursor extends Component {
    private int pointerOffsetX = 0;
    private int pointerOffsetY = 0;

    public Cursor() {
        super(REPAINT_ON_NULL_TEXTURE | REPAINT_ON_RESIZE);
        this.setLocalZOrder(Integer.MAX_VALUE);
        this.setSize(16, 16);
        this.pointerOffsetX = 1;
        this.pointerOffsetY = 14;
    }

    public int getPointerX() {
        return this.getGlobalX() + this.pointerOffsetX;
    }

    public int getPointerY() {
        return this.getGlobalY() + this.pointerOffsetY;
    }
    
    public void setPointerPos(int x, int y) {
        x = MathUtil.clamp(x, 0, GameApp.getGraphicsLayer().getWidth()) - this.pointerOffsetX;
        y = MathUtil.clamp(y, 0, GameApp.getGraphicsLayer().getHeight()) - this.pointerOffsetY;
        this.setAbsolutePosition(x, y);
    }

    @Override
    protected void repaint() {
        this.setTexture(TextureLoader.getTexture("Textures/Cursor.png"));
    }

    @Override
    public boolean isGhost() {
        return true;
    }
}
