/*
 * This software is the proprietary information of nico3000.
 */
package mesh.loader.generic;

import graphics.geometry.Geometry;
import graphics.geometry.IndexBuffer;
import graphics.geometry.VertexBuffer;
import mesh.IndexBufferInterval;
import mesh.loader.GeometryLoader;
import org.w3c.dom.Node;

/**
 * Erzeugt ein generisches Mesh aus vorgegebenem Index- und Vertexbuffer.
 * @author nico3000
 */
public class GenericLoader implements GeometryLoader {
    private final VertexBuffer vertexBuffer;
    private final IndexBuffer indexBuffer;

    public GenericLoader(VertexBuffer vertexBuffer, IndexBuffer indexBuffer) {
        this.vertexBuffer = vertexBuffer;
        this.indexBuffer = indexBuffer;
    }

    @Override
    public void setAdditionalData(Node data) {
        // not supported
    }

    @Override
    public Geometry load() {
        return Geometry.initGeometry(this.vertexBuffer, this.indexBuffer);
    }

    @Override
    public void release() {
        // nothing to release
    }

    @Override
    public String getCustomMaterialLibrary() {
        return null;
    }
    
}
