/*
 * Copyright (C) 2013 nico3000 - All Rights Reserved
 */
package scripting;

/**
 * Interface fuer eine Scripting Sprache.
 * @author nico3000
 */
public interface ScriptManager {
    /**
     * Initialisiert die Scripting Sprache.
     * @return <tt>true</tt>, falls erfolgreich
     */
    public boolean init();
    
    /**
     * Loescht alle zugehoerigen Daten.
     */
    public void destroy();
    
    /**
     * Laedt eine Datei und fuehrt sie aus.
     * @param resource Die Resource der Datei
     */
    public void executeFile(String resource);
    
    /**
     * Fuehrt einen String direkt aus.
     * @param source Der String
     */
    public void executeString(String fileName, String source);
    
    /**
     * Ruft eine Script Funktion auf
     * @param name Name der Funktion
     * @param args Argumente der Funktion
     */
    public Object invokeFunction(String name, Object ... args);
    
    public String getStringValue(String name, Object obj);
}
