/*
 * Copyright (C) 2012 nico3000 - All Rights Reserved
 */
package test;

import java.util.logging.Level;
import java.util.logging.Logger;
import process.EngineProcess;
import process.ProcessManager;

/**
 *
 * @author nico3000
 */
public class ProcessTest {
    public static void main(String argv[]) {
        EngineProcess p5 = new OutputProcess("...5...");
        EngineProcess p5d = new DelayProcess(1000);
        EngineProcess p4 = new OutputProcess("...4...");
        EngineProcess p4d = new DelayProcess(1000);
        EngineProcess p3 = new OutputProcess("...3...");
        EngineProcess p3d = new DelayProcess(1000);
        EngineProcess p2 = new OutputProcess("...2...");
        EngineProcess p2d = new DelayProcess(1000);
        EngineProcess p1 = new OutputProcess("...1...");
        EngineProcess p1d = new DelayProcess(1000);
        EngineProcess p0 = new OutputProcess("Boom!");
        p5.attachChild(p5d);
        p5d.attachChild(p4);
        p4.attachChild(p4d);
        p4d.attachChild(p3);
        p3.attachChild(p3d);
        p3d.attachChild(p2);
        p2.attachChild(p2d);
        p2d.attachChild(p1);
        p1.attachChild(p1d);
        p1d.attachChild(p0);
        ProcessManager mgr = new ProcessManager();
        mgr.attachProcess(p5);
        
        long last = System.currentTimeMillis();
        long sum = 0;
        while(sum < 6000) {
            long now = System.currentTimeMillis();
            long delta = now - last;
            mgr.update(delta);
            last = now;
            sum += delta;
            try {
                Thread.sleep(10);
            } catch (InterruptedException ex) {
                Logger.getLogger(ProcessTest.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        System.out.println("done");
    }
    
    private static class OutputProcess extends EngineProcess {
        private final String output;

        public OutputProcess(String output) {
            this.output = output;
        }

        @Override
        protected void onUpdate(long dMillis) {
            System.out.println(this.output);
            this.succeed();
        }
    }
    
    private static class DelayProcess extends EngineProcess {
        private long delayInMillis;

        public DelayProcess(long delayInMillis) {
            this.delayInMillis = delayInMillis;
        }
        
        @Override
        protected void onUpdate(long dMillis) {
            if((this.delayInMillis -= dMillis) <= 0) {
                this.succeed();
            }
        }
        
    }
}
